# ConsoleGuessGame

Description:
* Sample application for demonstrating development of manageable applications.

Usage:
1. Requirements: at least .NET Framework 4.6
   (The application uses MS Enterprise Library 6 components,
   but these components are included in the lib folder of the application.)
2. Unblock the exe and ps1 files in the application
   Locate the exe and ps1 files / Properties / Unblock button
3. Create the performance counters for the application with the following script (as administrator):

    src/Create-GuessGamePerformanceCounters.ps1 

4. Install the WMI provider of the application (as administrator):

    c:\Windows\Microsoft.NET\Framework\v4.0.30319\InstallUtil.exe ConsoleGuessGame.exe

5. Optionally modify the security descriptor of the application for running the program as non-administrator:

    Get-WmiObject -Class WMI_Extension -Namespace root\irf |  % { $_.SecurityDescriptor = "O:WDG:WDD:(A;;0x1;;;WD)"; $_.Put() }

6. Register the application as an event source (as administrator), execute the following in PowerShell:

    [System.Diagnostics.EventLog]::CreateEventSource("ConsoleGuessGame", "Application")

7. Review the config file for the application, adjust logging settings
8. Run ConsoleGuessGame.exe
9. You can query the WMI provider with the following command

    Get-CimInstance -ClassName IRF_GuessGame -Namespace root/irf
  
Build:
* To rebuild the applications the following components need to be installed:
 * .NET Framework 4.5
 * MS Enterprise Library 6
   The application uses NuGet to download it
   (optionally get it from http://msdn.microsoft.com/en-us/library/dn169621.aspx)
 * StyleCop (for checking the coding style)
   http://stylecop.codeplex.com/
   (install MSBuild integration component)
   The current release of StyleCop (4.7.51.0) still requires .NET FW 3.5
   Update the location of StyleCop in the 'Import' tag in ConsoleGuessGame.csproj if needed
 * Optional: Reference assemblies for .NET Framework 4.6
   To remove the 3 warnings about rerference assemblies, install the appropriate Targeting Pack
   URL: http://getdotnet.azurewebsites.net/target-dotnet-platforms.html